/**
    * @license
    * Copyright 2022 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
import*as t from"@tensorflow-models/body-segmentation";import*as e from"@tensorflow/tfjs-converter";import*as n from"@tensorflow/tfjs-core";var r=function(){return r=Object.assign||function(t){for(var e,n=1,r=arguments.length;n<r;n++)for(var o in e=arguments[n])Object.prototype.hasOwnProperty.call(e,o)&&(t[o]=e[o]);return t},r.apply(this,arguments)};function o(t,e,n,r){return new(n||(n=Promise))((function(o,i){function a(t){try{u(r.next(t))}catch(t){i(t)}}function s(t){try{u(r.throw(t))}catch(t){i(t)}}function u(t){var e;t.done?o(t.value):(e=t.value,e instanceof n?e:new n((function(t){t(e)}))).then(a,s)}u((r=r.apply(t,e||[])).next())}))}function i(t,e){var n,r,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function s(i){return function(s){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(o=2&i[0]?r.return:i[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,i[1])).done)return o;switch(r=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,r=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(o=a.trys,(o=o.length>0&&o[o.length-1])||6!==i[0]&&2!==i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=e.call(t,a)}catch(t){i=[6,t],r=0}finally{n=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,s])}}}function a(t,e,n,r){var o=e-t,i=r-n;if(0===o)throw new Error("Original min and max are both "+t+", range cannot be 0.");var a=i/o;return{scale:a,offset:n-t*a}}function s(t){return t instanceof SVGAnimatedLength?t.baseVal.value:t}function u(t){return o(this,void 0,void 0,(function(){var e,r;return i(this,(function(o){switch(o.label){case 0:return e=document.createElement("canvas"),t instanceof n.Tensor?[4,n.browser.toPixels(t,e)]:[3,2];case 1:return o.sent(),[3,3];case 2:e.width=s(t.width),e.height=s(t.height),r=e.getContext("2d"),t instanceof ImageData?r.putImageData(t,0,0):r.drawImage(t,0,0),o.label=3;case 3:return[2,e]}}))}))}function l(t,e){if("webgl"===n.getBackend())return function(t,e){var r={variableNames:["image","segmentation"],outputShape:t.shape,userCode:"\n  void main() {\n      ivec3 coords = getOutputCoords();\n      int height = coords[0];\n      int width = coords[1];\n      int channel = coords[2];\n      float value = getImage(height, width, channel);\n      float foregroundProbability = getSegmentation(height, width, 0);\n      setOutput(foregroundProbability >= 0.5 ? value : 0.0);\n    }\n"},o=n.backend().compileAndRun(r,[t,e]);return n.engine().makeTensorFromDataId(o.dataId,o.shape,o.dtype)}(t,e);var r=t.shape,o=r[0],i=r[1],a=r[2],s=n.slice(e,0,[o,i,1]),u=n.round(s),l=n.tile(u,[1,1,a]);return n.mul(t,l)}var c={depthModelUrl:"https://tfhub.dev/tensorflow/tfjs-model/ar_portrait_depth/1"},f=!1;var h,d=function(){function t(t){this.depthTensor=t}return t.prototype.toCanvasImageSource=function(){return o(this,void 0,void 0,(function(){return i(this,(function(t){return[2,u(this.depthTensor)]}))}))},t.prototype.toArray=function(){return o(this,void 0,void 0,(function(){return i(this,(function(t){return[2,this.depthTensor.arraySync()]}))}))},t.prototype.toTensor=function(){return o(this,void 0,void 0,(function(){return i(this,(function(t){return[2,this.depthTensor]}))}))},t.prototype.getUnderlyingType=function(){return"tensor"},t}(),p=a(0,255,0,1),m=function(){function t(t,e){this.segmenter=t,this.estimatorModel=e}return t.prototype.estimateDepth=function(t,e){return o(this,void 0,void 0,(function(){var o,s,u,c,h,m,v,g,b=this;return i(this,(function(i){switch(i.label){case 0:return o=function(t){if(null==t||null==t.minDepth||null==t.maxDepth)throw new Error("An estimation config with minDepth and maxDepth set must be provided.");if(t.minDepth>t.maxDepth)throw new Error("minDepth must be <= maxDepth.");var e=r({},t);return null==e.flipHorizontal&&(e.flipHorizontal=f),e}(e),null==t?(this.reset(),[2,null]):(s=n.tidy((function(){var e,r=n.cast((e=t)instanceof n.Tensor?e:n.browser.fromPixels(e),"float32");if(o.flipHorizontal){r=n.squeeze(n.image.flipLeftRight(n.expandDims(r,0)),[0])}return r})),u=s.shape,c=u[0],h=u[1],[4,this.segmenter.segmentPeople(s)]);case 1:return m=i.sent(),[4,m[0].mask.toTensor()];case 2:return v=i.sent(),g=n.tidy((function(){var t=l(s,v);v.dispose();var e=n.add(n.mul(t,p.scale),p.offset),r=n.image.resizeBilinear(e,[256,192]),i=n.expandDims(r),u=b.estimatorModel.predict(i),f=a(o.minDepth,o.maxDepth,0,1),d=f.scale/2,m=n.add(n.mul(u,d),f.offset),g=n.clipByValue(m,0,1),w=n.image.resizeBilinear(g,[c,h]);return n.squeeze(w,[0,3])})),s.dispose(),[2,new d(g)]}}))}))},t.prototype.dispose=function(){this.segmenter.dispose(),this.estimatorModel.dispose()},t.prototype.reset=function(){this.segmenter.reset()},t}();function v(n){return o(this,void 0,void 0,(function(){var o,a,s,u;return i(this,(function(i){switch(i.label){case 0:return o=function(t){if(null==t)return r({},c);var e=r({},t);return null==e.depthModelUrl&&(e.depthModelUrl=c.depthModelUrl),e}(n),a="string"==typeof o.depthModelUrl&&o.depthModelUrl.indexOf("https://tfhub.dev")>-1,[4,e.loadGraphModel(o.depthModelUrl,{fromTFHub:a})];case 1:return s=i.sent(),[4,t.createSegmenter(t.SupportedModels.MediaPipeSelfieSegmentation,{runtime:"tfjs",modelUrl:o.segmentationModelUrl})];case 2:return u=i.sent(),[2,new m(u,s)]}}))}))}function g(t,e){return o(this,void 0,void 0,(function(){return i(this,(function(n){if(t===h.ARPortraitDepth)return[2,v(e)];throw new Error(t+" is not a supported model name.")}))}))}!function(t){t.ARPortraitDepth="ARPortraitDepth"}(h||(h={}));export{h as SupportedModels,g as createEstimator};
